/****************************************************************************
**
** Copyright (C) 2016 The Qt Company Ltd.
** Contact: https://www.qt.io/licensing/
**
** This file is part of the QtQuick module of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:LGPL$
** Commercial License Usage
** Licensees holding valid commercial Qt licenses may use this file in
** accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and The Qt Company. For licensing terms
** and conditions see https://www.qt.io/terms-conditions. For further
** information use the contact form at https://www.qt.io/contact-us.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 3 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL3 included in the
** packaging of this file. Please review the following information to
** ensure the GNU Lesser General Public License version 3 requirements
** will be met: https://www.gnu.org/licenses/lgpl-3.0.html.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License version 2.0 or (at your option) the GNU General
** Public license version 3 or any later version approved by the KDE Free
** Qt Foundation. The licenses are as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3
** included in the packaging of this file. Please review the following
** information to ensure the GNU General Public License requirements will
** be met: https://www.gnu.org/licenses/gpl-2.0.html and
** https://www.gnu.org/licenses/gpl-3.0.html.
**
** $QT_END_LICENSE$
**
****************************************************************************/

#ifndef KQUICKTIMELINE_H
#define KQUICKTIMELINE_H

//
//  W A R N I N G
//  -------------
//
// This file is not part of the Qt API.  It exists purely as an
// implementation detail.  This header file may change from version to
// version without notice, or even be removed.
//
// We mean it.
//

#include <QtCore/QObject>
#include <private/qtquickglobal_p.h>
#include "private/qabstractanimationjob_p.h"

QT_BEGIN_NAMESPACE

class QEasingCurve;
class KQuickTimeLineValue;
class KQuickTimeLineCallback;
struct KQuickTimeLinePrivate;
class KQuickTimeLineObject;
class Q_QUICK_PRIVATE_EXPORT KQuickTimeLine : public QObject, QAbstractAnimationJob
{
Q_OBJECT
public:
    KQuickTimeLine(QObject *parent = nullptr);
    ~KQuickTimeLine();

    enum SyncMode { LocalSync, GlobalSync };
    SyncMode syncMode() const;
    void setSyncMode(SyncMode);

    void pause(KQuickTimeLineObject &, int);
    void callback(const KQuickTimeLineCallback &);
    void set(KQuickTimeLineValue &, qreal);

    int accel(KQuickTimeLineValue &, qreal velocity, qreal accel);
    int accel(KQuickTimeLineValue &, qreal velocity, qreal accel, qreal maxDistance);
    int accelDistance(KQuickTimeLineValue &, qreal velocity, qreal distance);

    void move(KQuickTimeLineValue &, qreal destination, int time = 500);
    void move(KQuickTimeLineValue &, qreal destination, const QEasingCurve &, int time = 500);
    void moveBy(KQuickTimeLineValue &, qreal change, int time = 500);
    void moveBy(KQuickTimeLineValue &, qreal change, const QEasingCurve &, int time = 500);

    void sync();
    void setSyncPoint(int);
    int syncPoint() const;

    void sync(KQuickTimeLineValue &);
    void sync(KQuickTimeLineValue &, KQuickTimeLineValue &);

    void reset(KQuickTimeLineValue &);

    void complete();
    void clear();
    bool isActive() const;

    int time() const;

    int duration() const override;
Q_SIGNALS:
    void updated();
    void completed();

protected:
    void updateCurrentTime(int) override;
    void debugAnimation(QDebug d) const override;

private:
    void remove(KQuickTimeLineObject *);
    friend class KQuickTimeLineObject;
    friend struct KQuickTimeLinePrivate;
    KQuickTimeLinePrivate *d;
};

class Q_AUTOTEST_EXPORT KQuickTimeLineObject
{
public:
    KQuickTimeLineObject();
    virtual ~KQuickTimeLineObject();

protected:
    friend class KQuickTimeLine;
    friend struct KQuickTimeLinePrivate;
    KQuickTimeLine *_t;
};

class Q_AUTOTEST_EXPORT KQuickTimeLineValue : public KQuickTimeLineObject
{
public:
    KQuickTimeLineValue(qreal v = 0.) : _v(v) {}

    virtual qreal value() const { return _v; }
    virtual void setValue(qreal v) { _v = v; }

    KQuickTimeLine *timeLine() const { return _t; }

    operator qreal() const { return _v; }
    KQuickTimeLineValue &operator=(qreal v) { setValue(v); return *this; }
private:
    friend class KQuickTimeLine;
    friend struct KQuickTimeLinePrivate;
    qreal _v;
};

class Q_AUTOTEST_EXPORT KQuickTimeLineCallback
{
public:
    typedef void (*Callback)(void *);

    KQuickTimeLineCallback();
    KQuickTimeLineCallback(KQuickTimeLineObject *b, Callback, void * = nullptr);
    KQuickTimeLineCallback(const KQuickTimeLineCallback &o);

    KQuickTimeLineCallback &operator=(const KQuickTimeLineCallback &o);
    KQuickTimeLineObject *callbackObject() const;

private:
    friend struct KQuickTimeLinePrivate;
    Callback d0;
    void *d1;
    KQuickTimeLineObject *d2;
};

template<class T>
class KQuickTimeLineValueProxy : public KQuickTimeLineValue
{
public:
    KQuickTimeLineValueProxy(T *cls, void (T::*func)(qreal), qreal v = 0.)
    : KQuickTimeLineValue(v), _class(cls), _setFunctionReal(func), _setFunctionInt(nullptr)
    {
        Q_ASSERT(_class);
    }

    KQuickTimeLineValueProxy(T *cls, void (T::*func)(int), qreal v = 0.)
    : KQuickTimeLineValue(v), _class(cls), _setFunctionReal(0), _setFunctionInt(func)
    {
        Q_ASSERT(_class);
    }

    void setValue(qreal v) override
    {
        KQuickTimeLineValue::setValue(v);
        if (_setFunctionReal) (_class->*_setFunctionReal)(v);
        else if (_setFunctionInt) (_class->*_setFunctionInt)((int)v);
    }

private:
    T *_class;
    void (T::*_setFunctionReal)(qreal);
    void (T::*_setFunctionInt)(int);
};

QT_END_NAMESPACE

#endif
